<?php
$method = "gd2";
$jpeg_qual = "80";
$file_mode = "0644";
//Function to resize images using GD1, & GD2.......

function resize_image($src_file, $dest_file, $new_size, $method) {
    global $CONFIG, $method, $file_mode, $jpeg_qual;
    $imginfo = getimagesize($src_file);
    if ($imginfo == null)
        return false;
    // GD can only handle JPG & PNG images
    if ($imginfo[2] != 2 && $imginfo[2] != 3 && ($method == 'gd1' || $method == 'gd2')){
        echo "Thumbnail Resize Invalid Filetype";
        return false;
    }
    // height/width
    $srcWidth = $imginfo[0];
    $srcHeight = $imginfo[1];
    $ratio = max($srcWidth, $srcHeight) / $new_size;
    $ratio = max($ratio, 1.0);
    $destWidth = (int)($srcWidth / $ratio);
    $destHeight = (int)($srcHeight / $ratio);
    // Method for thumbnails creation
    switch ($method) {
    case "gd1" :
    if (!function_exists('imagecreatefromjpeg')) {
             die("GD image library is not installed, ask your your webhost to install the GD Library.");
         }
        if ($imginfo[2] == GIS_JPG)
            $src_img = imagecreatefromjpeg($src_file);
        else
            $src_img = imagecreatefrompng($src_file);
        if (!$src_img){
            echo "Thumbnail Resize Invalid Image";
            return false;
        }
        $dst_img = imagecreate($destWidth, $destHeight);
        imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $destWidth, (int)$destHeight, $srcWidth, $srcHeight);
        imagejpeg($dst_img, $dest_file, $jpeg_qual);
        imagedestroy($src_img);
        imagedestroy($dst_img);
        break;

        case "gd2" :
    //echo "Converted using GD 2";
    if (!function_exists('imagecreatefromjpeg')) {
             die("The GD image library is not supported on this server, try using ImageMagick");
         }
         if (!function_exists('imagecreatetruecolor')) {

             die("GD version 2 is not supported on this server, please use GD version 1 instead");
         }
        if ($imginfo[2] == 2)
            $src_img = imagecreatefromjpeg($src_file);
        else
            $src_img = imagecreatefrompng($src_file);
        if (!$src_img){
            echo "Thumbnail Resize - Invalid Image";
            return false;
        }
        $dst_img = imagecreatetruecolor($destWidth, $destHeight);
        imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $destWidth, (int)$destHeight, $srcWidth, $srcHeight);
        imagejpeg($dst_img, $dest_file, $jpeg_qual);
        imagedestroy($src_img);
        imagedestroy($dst_img);
        break;
    }
    // Set mode of uploaded picture - not required in this version of this function
    //chmod($dest_file, octdec($file_mode));
    // We check that the image is valid
    $imginfo = getimagesize($dest_file);
    if ($imginfo == null){
        echo "ERROR! the resizing of the thumbnail failed";
        @unlink($dest_file);
        return false;
    } else {
        $orig_file = $dest_file;
        $orig_file = str_replace("1","",$orig_file);
        @unlink($orig_file);
        rename ($dest_file,$orig_file);
        return true;
    }
}
?>